// ../shared/src/ts.utils.ts
function never(neverCheck, value) {
  throw new Error(
    `Unexpected value, received: ${JSON.stringify(value ?? neverCheck, null, 2)}`
  );
}

// src/message.builder.ts
import { pipe } from "@synstack/resolved";
import { t, tParse } from "@synstack/text";
var userMsg = (template, ...values) => pipe(t(template, ...values))._(tParse)._(
  (parts) => parts.map((v) => {
    if (typeof v === "string")
      return { type: "text", text: v };
    if (v.type === "base64")
      return {
        type: "image",
        image: v
      };
    never(v.type);
  })
)._(
  (content) => ({
    role: "user",
    content
  })
).$;
var assistantMsg = (template, ...values) => {
  return pipe(t(template, ...values))._(tParse)._(
    (parts) => parts.map((v) => {
      if (typeof v === "string")
        return { type: "text", text: v };
      if (v.type === "tool_call") return v;
      never(v.type);
    })
  )._(
    (content) => ({
      role: "assistant",
      content
    })
  ).$;
};
export {
  assistantMsg,
  userMsg
};
//# sourceMappingURL=llm.index.js.map